/*
 * Copyright 1998 by Kenneth C. Dyke
 *       All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appears in all copies and
 * that both the copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT, OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
 * NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#import "InfoPanelController.h"

@implementation InfoPanelController

+ (id)sharedInfoPanelController {
    static InfoPanelController *sharedInfoPanelController = nil;

    if (!sharedInfoPanelController) {
        sharedInfoPanelController = [[InfoPanelController allocWithZone:NULL] init];
    }

    return sharedInfoPanelController;
}

- (id)init {
    return [self initWithWindowNibName:@"InfoPanel"];
}

- (IBAction)showWindow:(id)sender {
    [[self window] center];
    [super showWindow:sender];
}

@end
